<template>
  <CForm
    class="customer-search-form"
    @submit.prevent="onSubmit"
  >
    <div class="row">
      <div class="col-12 col-xl-6">
        <CSelect
          v-model="category"
          label="カテゴリ"
          horizontal
          :options="categoryList"
          placeholder="カテゴリ"
          :value.sync="category"
        >
          <template #prepend-content>
            <font-awesome-icon :icon="['fas', 'th']" class="width-1x" />
          </template>
        </CSelect>
      </div>

      <div class="col-12 col-xl-6">
        <div role="group" class="form-group form-row">
          <CCol tag="label" sm="3" class="col-form-label">
            状態
          </CCol>
          <CCol sm="9" class="form-inline">
            <app-radio-group
              v-model="status"
              :list="BOX_STATUS_LIST"
              :name="'participation'"
              :inline="true"
            />
          </CCol>
        </div>
      </div>
    </div>

    <div class="row">
      <div class="col-12 col-xl-6">
        <CInput
          v-model="name"
          type="text"
          label="お名前"
          placeholder="お名前"
          horizontal
        >
          <template #prepend-content>
            <font-awesome-icon :icon="['fas', 'user-alt']" class="width-1x" />
          </template>
        </CInput>
      </div>
    </div>

    <div class="box-form-footer form-group">
      <CButton
        type="submit"
        color="primary"
        :disabled="disabled || loading"
      >
        <font-awesome-icon :icon="['fas', 'search']" class="width-1x" />
        検索
      </CButton>
      &nbsp;
      <CButton
        color="secondary"
        :disabled="loading"
        @click="onClearFormSearch"
      >
        <font-awesome-icon :icon="['fas', 'eraser']" class="width-1x" />
        クリア
      </CButton>
    </div>
  </CForm>
</template>

<style lang="scss" scoped>
  .customer-search-form {
    /deep/ {
      .col-form-label {
        text-align: right;
        @include mq(max_lg) {
          text-align: left;
        }
      }
      .box-form-footer {
        text-align: center;
        .btn {
          min-width: 100px;
        }
      }
    }
  }
</style>

<script>
import { isEqual } from 'lodash'

import { BOX_STATUS_LIST } from '~/constants'

import AppRadioGroup from '~/components/atoms/AppRadioGroup'

const EVENT_SEARCH = 'onSearch'

export default {
  components: {
    AppRadioGroup
  },

  props: {
    /**
     * Default condition
     */
    defaultCondition: {
      type: Object,
      default: () => {}
    },

    /**
     * Loading status
     */
    loading: {
      type: Boolean,
      default: false
    }
  },

  data () {
    return {
      // Form search
      category: null,
      name: null,
      status: null,
      data: [],

      // Previous codition
      prevCondition: null
    }
  },
  computed: {
    /**
     * Get PARTICIPATION_LIST
     *
     * @return {Array} PARTICIPATION_LIST
     */
    BOX_STATUS_LIST () {
      return BOX_STATUS_LIST
    },

    /**
     * Check disable status of button search
     *
     * @return {Boolean} Disable status of button search
     */
    disabled () {
      if (this.prevCondition === null) {
        return false
      }

      return isEqual(this.prevCondition, this.condition)
    },

    /**
     * Return list category item options
     *
     */
    categoryList () {
      const options = []
      this.data.forEach((item) => {
        const param = { value: item.id, label: item.name }
        options.push(param)
      })
      return options
    }
  },

  watch: {
    /**
     * watch value change of name
     */
    'name' (val) {
      this.onSearch()
    },

    /**
     * watch value change of status
     */
    'status' (val) {
      this.onSearch()
    },

    /**
     * watch value change of category
     */
    'category' (val) {
      this.onSearch()
    }
  },

  mounted () {
    this.prepareData()
  },

  methods: {
    /**
     * Clean all condition data on form
     */
    onClearFormSearch () {
      this.name = null
      this.status = null
      this.fromDate = null
      this.toDate = null
    },

    /**
     * Prepare data
     */
    prepareData () {
      this.$dam.getBoxList()
        .then((res) => {
          this.data = [{ id: res.category_id, name: 'お酒' }]
        })
        .catch((err) => {
          console.error(err)
        })
    },

    /**
     * Emit search event with condition
     */
    onSearch () {
      const params = {
        name: this.name,
        status: this.status,
        category: this.category
      }
      this.$emit(EVENT_SEARCH, params)
    }
  }
}
</script>
